unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CelikApi, ExtCtrls;

type
  TForm1 = class(TForm)
    btnCitajKarticu: TButton;
    btnSaveMemoToFile: TButton;
    btnLoadFromFile: TButton;
    imgPic: TImage;
    Memo1: TMemo;
    procedure btnCitajKarticuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSaveMemoToFileClick(Sender: TObject);
    procedure btnLoadFromFileClick(Sender: TObject);
  private
    procedure DisplayData(const ADocData: TNormDocumentData; AFixPerData: TNormFixedPersonalData; AVarPerData: TNormVariablePersonalData);
    procedure DisplayPicture(const AImg: TStream);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Jpeg;

procedure TForm1.btnCitajKarticuClick(Sender: TObject);
var
  DocData: TNormDocumentData;
  FixedData: TNormFixedPersonalData;
  VariableData: TNormVariablePersonalData;
  ms: TMemoryStream;
//  r : integer;
begin
  ms := TMemoryStream.Create;
  try
    EidBeginRead('');
//    r := EidBeginRead('');
//    ShowMessage(IntToStr(r));
    NormReadDocumentData(DocData);
    NormReadFixedPersonalData(FixedData);
    NormReadVariablePersonalData(VariableData);
    NormReadPicture(ms);
    EidEndRead;

    DisplayData(DocData, FixedData, VariableData);
    DisplayPicture(ms);
  finally
    ms.Free;
  end;
end;

procedure TForm1.DisplayData(const ADocData: TNormDocumentData; AFixPerData: TNormFixedPersonalData; AVarPerData: TNormVariablePersonalData);
begin
  Memo1.Clear;
  Memo1.Lines.Add('Reg.no: ' + ADocData.DocRegNo);
  Memo1.Lines.Add('Tip dokumenta: ' + ADocData.DocumentType);
  Memo1.Lines.Add('Datum izdavanja: ' + ADocData.IssuingDate);
  Memo1.Lines.Add('Datum isteka: ' + ADocData.ExpiryDate);
  Memo1.Lines.Add('Izdaje: ' + ADocData.IssuingAuthority);

  Memo1.Lines.Add('-----------------------------------------');
  Memo1.Lines.Add('Prezime: ' + AFixPerData.Surname);
  Memo1.Lines.Add('Ime: ' + AFixPerData.GivenName);
  Memo1.Lines.Add('Ime roditelja: ' + AFixPerData.ParentGivenName);
  Memo1.Lines.Add('Pol: ' + AFixPerData.Sex);
  Memo1.Lines.Add('Mesto roenja: ' + AFixPerData.PlaceOfBirth);
  Memo1.Lines.Add('Drava: ' + AFixPerData.StateOfBirth);
  Memo1.Lines.Add('Datum roenja: ' + AFixPerData.DateOfBirth);
  Memo1.Lines.Add('Optina: ' + AFixPerData.CommunityOfBirth);

  Memo1.Lines.Add('-----------------------------------------');
  Memo1.Lines.Add('Prebivalite - oznaka drave: ' + AVarPerData.state);
  Memo1.Lines.Add('Prebivalite - optina: ' + AVarPerData.community);
  Memo1.Lines.Add('Prebivalite - mesto: ' + AVarPerData.place);
  Memo1.Lines.Add('Prebivalite - ulica: ' + AVarPerData.street);
  Memo1.Lines.Add('Prebivalite - kuni broj: ' + AVarPerData.houseNumber);
  Memo1.Lines.Add('Prebivalite - slovo uz broj: ' + AVarPerData.houseLetter);
  Memo1.Lines.Add('Prebivalite - ulaz: ' + AVarPerData.entrance);
  Memo1.Lines.Add('Prebivalite - sprat: ' + AVarPerData.floor);
  Memo1.Lines.Add('Prebivalite - broj stana: ' + AVarPerData.apartmentNumber);
  Memo1.Lines.Add('Prebivalite - promena datuma: ' + AVarPerData.AddressDate);
  Memo1.Lines.Add('Prebivalite - neka adresna oznaka (sta god da znacila a verovatno ima veze sa promenom datuma): ' + AVarPerData.AddressLabel);

end;

procedure TForm1.FormCreate(Sender: TObject);
//var
// r : integer;
begin
  EidStartup(2);
//  r := EidStartup(2);
//  ShowMessage(IntToStr(r));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  EidCleanup;
end;

procedure TForm1.btnSaveMemoToFileClick(Sender: TObject);
var
  DocData: TEidDocumentData;
  FixedData: TEidFixedPersonalData;
  VariableData: TEidVariablePersonalData;
  f: TFileStream;
begin
  FillChar(DocData, SizeOf(TEidDocumentData), 0);
  FillChar(FixedData, SizeOf(TEidFixedPersonalData), 0);
  FillChar(VariableData, SizeOf(TEidVariablePersonalData), 0);

  EidBeginRead('');
  EidReadDocumentData(@DocData);
  EidReadFixedPersonalData(@FixedData);
  EidReadVariablePersonalData(@VariableData);
  EidEndRead;

  f := TFileStream.Create('Data.dat', fmCreate);
  try
    f.Write(DocData, SizeOf(TEidDocumentData));
    f.Write(FixedData, SizeOf(TEidFixedPersonalData));
    f.Write(VariableData, SizeOf(TEidVariablePersonalData));
  finally
    f.Free;
  end;
end;

procedure TForm1.btnLoadFromFileClick(Sender: TObject);
var
  DocData: TEidDocumentData;
  FixedData: TEidFixedPersonalData;
  VariableData: TEidVariablePersonalData;
  f: TFileStream;
begin
  f := TFileStream.Create('Data.dat', fmOpenRead);
  try
    f.Read(DocData, SizeOf(TEidDocumentData));
    f.Read(FixedData, SizeOf(TEidFixedPersonalData));
    f.Read(VariableData, SizeOf(TEidVariablePersonalData));
  finally
    f.Free;
  end;
end;

procedure TForm1.DisplayPicture(const AImg: TStream);
var
  img: TJPEGImage;
begin
  if AImg.Size > 0 then
  begin
    img := TJPEGImage.Create;
    try
      AImg.Position := 0;
      img.LoadFromStream(AImg);
      imgPic.Picture.Assign(img);
    finally
      img.Free;
    end;
  end;
end;

end.

